<template>
  <div>
    <!-- Cuerpo -->
    <div style="margin: 0 4rem" class="padding-top">
      <!-- Headboard -->
      <el-header style="height: auto; margin: 0 2.75rem;">
        <el-row :gutter="15">
          <!-- Filtro -->
          <el-col :span="20" :offset="5">
            <el-col :span="9">
              <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
            </el-col>
            <el-col :span="11">
              <el-input 
                class="input-head"
                placeholder="Buscar"
                prefix-icon="el-icon-search"
                v-model="textSearch"
                @clear="cleanSearch"
                @keyup.enter.native="filterMaterials"
                clearable>
            </el-input>
            </el-col>
            <el-col  :span="2">
              <el-button @click="filterMaterials" type="primary" :disabled="textSearch==''"> BUSCAR </el-button>   
           </el-col>
          </el-col>
        </el-row>

        <!-- Subtítulo -->
        <el-col :span="24">
          <div class="titleSection">Lista de Segmentos</div>
        </el-col>
        <!-- Botón nuevo -->
        <div class="text-end" style="margin-top: 3rem">
          <el-button @click="goToNewSegment" type="primary">NUEVO SEGMENTO</el-button>
        </div>
      </el-header>
       <!-- Tarjeta 'No hay resultado' -->
      <el-row v-bind:class="[ segments.length == 0 ? 'remove-grid-container' : 'grid-container' ]" v-if="isShowNoResults" >
        <el-col :span="20" :offset="2">      
          <el-card :body-style="{ padding: '0px' }" class="bg-gray">
            <el-col :span="8" style="margin-top: 1rem" class="text-center">
              <img src="../../assets/images/detective.svg" alt="">
            </el-col>
            <el-col :span="16">
              <div style="margin-top: 5rem">
                <p class="title-styles">¡Lo sentimos!</p>
                <p class="title-styles">No encontramos resultados para tu búsqueda </p>
              </div>
            </el-col>
          </el-card>
        </el-col>
      </el-row>
      <!-- Tarjetas -->
      <el-row v-bind:class="[ segments.length == 0 ? 'remove-grid-container' : 'grid-container' ]" v-if="segments && segments.length" v-loading="loading" :element-loading-text="loadingText"> 
        <el-col 
          v-for="(segment, index) in segments.slice(0,30)" style="margin-bottom: 4rem"
          :key="segment.__id">
          <app-cards :principalTitle="segment.segmentTitle" :dataTable="segments[index].validity" :showvalidity="true" :emissionProp="[]"
                     :textModal="textModal" :uniqueId="segment._id" :item="segment" :cutRoute="''" :editRoute="editRoute" @executeEdit="editSegment($event)" @executeChangeStatus="statusChange(segment)"
                     :principalData="{0:{ class: 'bg-orange-ligth text-white', subTitle: 'Cod. Segmento', content: segment.codSegment} }"        
                     :showAmounts="true" :showTitleSegment="true"
                     :infoTitleSegment="{0:{ 
                                          left: {
                                            subTitle: 'Programa del Segmento',
                                            content: segment.programTitle
                                          }
                                        } 
                                        }" 

                      :rowsInfo="{
                        0: {   
                          hideAfiliado: false,                      
                          left: {
                            subtitle:'Horario',
	                          content: `<strong>Inicio:</strong>&nbsp;<span>${validationSchudle(segment.scheduleStartHour, segment.scheduleStartMin)}</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>Fin:</strong>&nbsp;<span>${validationSchudle(segment.scheduleEndHour, segment.scheduleEndMin)}</span>`
                          },
                          right: {
                            subtitle: 'Tipo de Contenido', 
	                          content: ''
                          }
                        },
                        1: {
                          hideAfiliado: false, 
                          left: {
                            subtitle: 'Clasificación', 
	                          content: `${segment.segmentClassification}- ${segment.segmentDescription}`
                          },
                          right: {
                            subtitle: 'Transmisión', 
	                          content: segment.transmissionDaysDescription
                          }
                        },
                        2: {
                          hideAfiliado: false,
                          left: {
                            subtitle: 'Señales',
                            content: (segment.checkedSignals).join(', ')
                          }
                        },
                     }"       
                   >
          </app-cards>
        </el-col>      
      </el-row>

    </div>
  </div>
</template>

<script>
import Cards from '@/components/cards.vue'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import { modifyText } from '../../utils/modifyText.js'
import {HTTP} from '../../main.js'

export default {
  components: {
    'app-cards': Cards,
    'app-search-filter': SearchFilter,
    'app-select': Select,
  },
  data () {
    return {
      textSearch: '',
      filterSelect: '',
      segmentsInfo: [],
      editRoute: 'editSegment',
      textModal: 'segmento',
      allSegments:[],
      searchSegments:[],
      allFilters: [
        {value: 'codSegment', label: 'Código'},
        {value: 'segmentType', label: 'Tipo'},
        {value: 'startValidity', label: 'Vigencia - Inicio'},
        {value: 'endValidity', label: 'Vigencia - Fin'}
      ],
      loading: true,
      loadingText: 'Cargando Segmentos...',
      isShowNoResults: false,
      IsClick: false
    }
  },
  computed: {
    segments() {return this.IsClick? this.searchSegments:this.allSegments }
  },
  created () {
    this.getSegments()
    this.verifyContent()
  },
  methods: {
    filterMaterials() {
      
      let cadenaConexion

      if ( this.filterSelect == 'startValidity' || this.filterSelect == 'endValidity' && this.textSearch !== ''  ) {
        var myDate = this.textSearch ;
        myDate=myDate.split("/");
        var newDate = myDate[1]+"/"+myDate[0]+"/"+myDate[2];
        var timestamp = new Date(newDate).getTime() 
        cadenaConexion =  HTTP.get(`segments/typeOfFilter/${this.filterSelect}/word/${ timestamp }`)
      }
      else if (this.filterSelect == '' &&  this.textSearch !== '' ) {   
        cadenaConexion =  HTTP.get(`segments/typeOfFilter/segmentTitle/word/${this.textSearch}`)
      }
      else {       
        cadenaConexion =  HTTP.get(`segments/typeOfFilter/${this.filterSelect}/word/${this.textSearch}`)
      }
      cadenaConexion
      .then(res=> {
        this.isShowNoResults = res.data.segments.length == 0  ? true : false
        this.searchSegments = res.data.segments;
        this.IsClick = true
      })
    },
    cleanSearch () {
      this.filterSelect =  ''
      this.isShowNoResults = false
      this.IsClick = false
    },
    validationSchudle(hour, mins) {
      if (hour !== undefined && hour !== '') {
        hour = hour
        if (mins != undefined) {
          if (mins !== '') {
            mins = ':' + mins
          }
          else {
            mins = ':00'
          }
          
        }
        else {
          mins = ':00'
        }
        
      }
      else {
        hour = ''
        mins = ''
      }
      return hour + ' ' + mins
    },
    getSegments () {
      this.$localStorage.set('segmentId', JSON.stringify(''));
      HTTP.get('segments')
      .then(res=>this.allSegments = res.data.segments)
    },
    goToNewSegment () {
      this.$router.push({ name: "newSegment" })
    },
    statusChange (item) {
      const payload = {
        type: 'segments',
        id: item._id,
        payloadInfo: item
      }
      this.$store.dispatch('changeStatus',payload)
    },
    editSegment (event) {
      let targetId = event.target.parentElement.parentElement.id;
      this.$localStorage.set('segmentId', JSON.stringify(targetId))
    },
    verifyContent() {
      if(this.segments.length > 0) {
        this.loading = false
      } else {
          this.loading = this.segments.length == 0 && this.textSearch !== '' ? false : true
      }
    }
  },
  watch: {
    segments(val) {
      this.verifyContent()
    }
  }
}
</script>

<style scoped>
  .titleSection{
    background: #4A4A4A;
    color: white;
    padding: 10px 10px 10px 35px;
    text-transform: uppercase;
    font-weight: 400;
    margin: 40px auto;
    font-size: 18px;
  }
</style>
